
#include <astro_swiss.mq4>
#include <astro_periods.mq4>
#include <vozrast.mq4>




/*
double get_astro_longtitude(int shift, int Body, int iflag)
{
   datetime d = get_datetime(shift);
   double longtitude, latitude, distance, speed;
   astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
   return(longtitude);
}
*/

double calculate_afeliy(int shift, int Body, int iflag)
{
   double astro_value = get_astro_gradus(shift, Body, iflag);
   double gradus_zero = 0;
   if(Body == -1) gradus_zero = 0;
   if(Body ==  1) gradus_zero = get_astro_gradus(shift, 12, 0);
   /*
   if(Body ==  2) gradus_zero =  81.0;
   if(Body ==  3) gradus_zero = 129.0;
   if(Body == 14) gradus_zero = 107.0;
   if(Body ==  4) gradus_zero = 338.0;
   if(Body ==  5) gradus_zero =  17.0;
   if(Body ==  6) gradus_zero =  94.0;
   */
   if(Body ==  2) gradus_zero = 259.0;
   if(Body ==  3) gradus_zero = 310.0;
   if(Body == 14) gradus_zero = 282.0;
   if(Body ==  4) gradus_zero = 156.0;
   if(Body ==  5) gradus_zero = 195.0;
   if(Body ==  6) gradus_zero = 271.0;
   
   astro_value = astro_value - gradus_zero;
   if(astro_value < 0) astro_value = astro_value + 360.0;   
   
   return(astro_value);
}


//   -  180
double func_P(double input1, double input2)
{
   if ( MathAbs(input1-input2) > 180 )
   {
     return( 360 - MathMax(input1, input2) + MathMin(input1, input2) );
   }
   else
   {
     return( MathAbs(input1-input2) );
   }
}

//   -  360
double func_P360(double fast, double slow)
{
   if (fast >= slow)
   {
     return( fast - slow );
   }
   else
   {
     return( 360 - (slow-fast) );
   }
}



bool is_retrograde(datetime d, int period, int Body, int iflag)
{
   double longtitude_past, latitude_past;
   double longtitude_now, latitude_now;
   double tmp;
   
   astro_swe_calc(d-period, Body, iflag, longtitude_past, latitude_past, tmp, tmp);
   astro_swe_calc(d, Body, iflag, longtitude_now, latitude_now, tmp, tmp);
   
   if(longtitude_now < longtitude_past)
   {
     return(1);
   }
   else
   {
     return(0);
   }
}







/*
// 
int astro_Sign(double value)
{
   return( MathFloor(value/30) );
}


///////////////////////////////////////////////////////////////

bool is_top_v180(double v180, double orbis,double value, double value_m1, double value_p1)
{
   if(
       //180
       ((value>value_m1)&&(value>value_p1))
       ||(v180-value<orbis)
     )
   {
     return(true);
   }
   else
   {
     return(false);
   }
}

bool is_bottom_v0(double orbis, double value, double value_m1, double value_p1)
{
   if(
       //0
       ((value<value_m1)&&(value<value_p1))
       ||(value<orbis)
     )
   {
     return(true);
   }
   else
   {
     return(false);
   }
}

bool is_gradus(double orbis, double value, double value_m1, double value_p1)
{
   if(
       //90
       (MathAbs(value-90)<orbis)
       ||
       ( (((value-90>0)&&(value_p1-90<0))||((value-90<0)&&(value_p1-90>0))) && (MathAbs(value-90)<MathAbs(value_p1-90)) )
       ||
       ( (((value-90>0)&&(value_m1-90<0))||((value-90<0)&&(value_m1-90>0))) && (MathAbs(value-90)<MathAbs(value_m1-90)) )
     )
   {
     return(true);
   }
   else
   {
     return(false);
   }
}
*/